diff --git a/src/lxc/namespace.c b/src/lxc/namespace.c
index aca29d4..86d1e53 100644
--- a/src/lxc/namespace.c
+++ b/src/lxc/namespace.c
@@ -82,7 +82,7 @@ pid_t lxc_clone(int (*fn)(void *), void *arg, int flags)
        return ret;
 }
 
-int lxc_attach(pid_t pid)
+int lxc_attach(pid_t pid, const char* cgname)
 {
        char path[MAXPATHLEN];
        char *ns[] = { "pid", "mnt", "net", "ipc", "uts" };
@@ -104,6 +104,13 @@ int lxc_attach(pid_t pid)
                        return -1;
                }
        }
+       pid_t cpid = getpid();
+
+       /* Let's add the pid to the 'tasks' file */
+       if (lxc_cgroup_append_task(cgname, cpid)) {
+               SYSERROR("failed to attach pid '%d' to '%s'", cpid, cgname);
+               return -1;
+       }
 
        for (i = 0; i < size; i++) {
                if (setns(fd[i], 0)) {
